/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pe.gob.sunat.tecnologia.receptor.cliente.forms;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <p>Verifica en intervalos de un segundo, que todos los envios hayan sido ejecutados,
 * para generar al final un archivo con todos los tickets retornados por el
 * receptor SEIDA.</p>
 * <p>El archivo generado es creado en el directorio de los acuses.</p>
 *
 * @author JVALDEZ
 */
public class CheckProcess extends Thread{
    protected final Log log = LogFactory.getLog(getClass());
    private Sender[] envios;
    private javax.swing.JTextArea areaMensajes;
    private String rutaArchivos;

    @Override
    public void run(){
        check();
    }

    /**
     * 
     */
    private void check() {
        boolean completo = false;
        while (!completo){
            int alives = 0;
            for (Thread envio : envios){
                if(envio.isAlive()) alives++;
            }
            
            if(alives == 0) {
                completo = true;
            } else {
                try {
                   Thread.sleep(1000);
                } catch (InterruptedException ex) {
                    log.error(this, ex);
                }
            }
        }
        BufferedWriter bufferedWriter = null;
        try {
            String fileName = this.rutaArchivos + "/" + "tickets_" + new java.util.Date().getTime() + ".txt";
            File f = new File(fileName);
            bufferedWriter = new BufferedWriter(new FileWriter(f));

            for (Sender envio : envios){
                bufferedWriter.write(envio.getAnhoEnvio() + "," + envio.getNumeroTicket() + "," + envio.getArchivoEnviar());
                bufferedWriter.newLine();
            }
            areaMensajes.append("\n\nArchivo con tickets " + fileName + " generado...\n");
            log.info("Archivo con tickets " + fileName + " generado...");
        } catch (FileNotFoundException ex) {
            log.error(this, ex);
        } catch (IOException ex) {
            log.error(this, ex);
        } finally {
            try {
                bufferedWriter.close();
            } catch (IOException ex) {
                log.error(this, ex);
            }
        }

        areaMensajes.append("\n\nProceso terminado...\n");
        log.info("Proceso terminado");
    }

    /**
     * @param areaMensajes the areaMensajes to set
     */
    public void setAreaMensajes(javax.swing.JTextArea areaMensajes) {
        this.areaMensajes = areaMensajes;
    }

    /**
     * @param envios the envios to set
     */
    public void setEnvios(Sender[] envios) {
        this.envios = envios;
    }

    /**
     * @param rutaArchivos the rutaArchivos to set
     */
    public void setRutaArchivos(String rutaArchivos) {
        this.rutaArchivos = rutaArchivos;
    }

}
