package pe.gob.sunat.tecnologia.receptor.cliente.util.security.handler;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import pe.gob.sunat.tecnologia.receptor.cliente.bean.SeguridadCliente;
import pe.gob.sunat.tecnologia.receptor.cliente.util.holder.SeguridadClienteHolder;

import com.sun.xml.wss.impl.callback.PasswordCallback;
import com.sun.xml.wss.impl.callback.UsernameCallback;
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class ClientSecurityEnvironmentHandler implements CallbackHandler {
  
    private static final UnsupportedCallbackException unsupported = new UnsupportedCallbackException(null, "Unsupported Callback Type Encountered");
   
    /** Creates a new instance of ClientSecurityEnvironmentHandler */
    public ClientSecurityEnvironmentHandler() {
    }
   
    private String readLine() throws IOException {
        return new BufferedReader(new InputStreamReader(System.in)).readLine();
    }

    public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException {
        SeguridadCliente cliente = SeguridadClienteHolder.get();
        for (int i=0; i < callbacks.length; i++) {
            if (callbacks[i] instanceof UsernameCallback) {
                
                UsernameCallback cb = (UsernameCallback)callbacks[i];
                
                String username = cliente.getUsuario();
                // System.out.println("Got Username......... : " + username);
                if (username != null) {
                    cb.setUsername(username);
                }
                
            } else if (callbacks[i] instanceof PasswordCallback) {
                
                PasswordCallback cb = (PasswordCallback)callbacks[i];
                
                String password = cliente.getClave();
                // System.out.println("Got Password......... : " + password);
                if (password != null) {
                    cb.setPassword(password);
                }
                
            } else {
                
                throw unsupported;
                
            }
        }
    }
   
}